/* bsp09.q: Einfache MIDI-Echtzeit-Anwendung (Transposition) */

import midi, mididev;

def (_,IN,_) = MIDIDEV!0, (_,OUT,PORT) = MIDIDEV!0, REF = midi_open "bsp09",
  _ = midi_connect IN REF || midi_connect REF OUT;

/* generische Eingabeschleife */

loop F (_,_,_,stop)		= ();
loop F (_,_,_,MSG)		= F MSG || loop F (midi_get REF) otherwise;

/* Transpositions-Verarbeitungsfunktion */

transp N (note_on C P V)	= midi_send REF PORT (note_on C (P+N) V);
transp N (note_off C P V)	= midi_send REF PORT (note_off C (P+N) V);
transp N (key_press C P V)	= midi_send REF PORT (key_press C (P+N) V);
transp N MSG			= midi_send REF PORT MSG otherwise;

/* Hauptfunktion */

private transpose N;

transpose N			= midi_flush REF ||
				  loop (transp N) (midi_get REF);
