/* bsp10.q: MIDI-Echtzeit-Anwendung mit Gedchtnis (Akkord-Protokoll) */

import midi, mididev;

def (_,IN,_) = MIDIDEV!0, (_,OUT,PORT) = MIDIDEV!0, REF = midi_open "bsp10",
  _ = midi_connect IN REF || midi_connect REF OUT;

/* generische Eingabeschleife mit Zustandsparameter */

loop F STATE (_,_,_,stop)	= ();
loop F STATE (_,_,_,MSG)	= loop F (F STATE MSG) (midi_get REF)
				    otherwise;

/* Verarbeitungsfunktion: Protokollieren des momentan klingenden Akkords */

c NOTES (note_on C P V)		= print NOTES || NOTES
				    where NOTES = insert NOTES P if V>0;
				= print NOTES || NOTES
				    where NOTES = delete NOTES P otherwise;
c NOTES (note_off C P V)	= print NOTES || NOTES
				    where NOTES = delete NOTES P;
c NOTES MSG			= NOTES otherwise;

/* Ausgabe des momentanen Akkords */

print NOTES			= printf "%s\n"
				  (join " - " (map note_name (list NOTES)));

def NAMES = ("C","C#","D","Eb","E","F","F#","G","G#","A","Bb","B");

note_name P			= sprintf "%s%d"
				  (NAMES!(P mod 12), P div 12);

/* Hauptfunktion */

chord				= midi_flush REF ||
				  loop c emptyset (midi_get REF);
