/* bsp12.q: Wiedergabe einer MIDI-Sequenz */

import midi, mididev;

def (_,IN,_) = MIDIDEV!0, (_,OUT,PORT) = MIDIDEV!0, REF = midi_open "bsp12",
  _ = midi_connect IN REF || midi_connect REF OUT;

def _ = midi_accept_type REF active_sense false ||
  midi_accept_type REF clock false;

/* Wiedergabeschleife */

playloop _ _ SEQ
		= SEQ if midi_avail REF and then (midi_get REF!3=stop);
playloop S T []	= [];
playloop S T [(S,MSG)|SEQ]
		= midi_send REF PORT MSG || print (T,MSG) ||
		  playloop S T SEQ;
playloop S T SEQ
		= playloop S1 T1 SEQ
		    where [(S1,_)|_] = SEQ, D = time_diff S S1,
		      T1 = midi_wait REF (T+D);

/* Berechnung der Zeitdifferenzen */

time_diff T1 T2	= ifelse (D>=0) D (D+0x100000000)
		    where D = T2 mod 0x100000000 - T1 mod 0x100000000;

/* Protokollieren der Ereignisse */

print (T,MSG)	= printf "%10d: %s\n" (T,str MSG);

/* Hauptfunktion */

public play SEQ;

play []		= [];
play SEQ	= midi_flush REF || playloop S T SEQ
		    where [(S,_)|_] = SEQ, T = midi_time;
