/* bsp15.q: Einlesen einer MIDI-Datei */

import midi;

def REF = midi_open "bsp15";

public load NAME;

load NAME		= convert (midi_file_division F)
			  (foldl mix [] (load_tracks F))
			    where F = midi_file_open NAME;

/* Einlesen der Spuren */

load_tracks F		= map (load_track F)
			  (nums 0 (midi_file_num_tracks F-1));

load_track F K		= map (cons K) (midi_file_read_track F);

/* Mischen der Spuren (vgl. bsp14.q) */

mix SEQ1 SEQ2		= SEQ1 if null SEQ2;
			= SEQ2 if null SEQ1;
			= [hd SEQ1|mix (tl SEQ1) SEQ2] if T1 <= T2
			    where (_,T1,_) = hd SEQ1, (_,T2,_) = hd SEQ2;
			= [hd SEQ2|mix SEQ1 (tl SEQ2)] otherwise;

/* Konvertieren der Zeitstempel in Millisekunden */

convert (FPS,TICKS) SEQ	= map (convert_smpte FPS TICKS) SEQ;

convert_smpte FPS TICKS (K,S,MSG)
			= (K,round (S/(FPS*TICKS)*1000),MSG);

convert PPQN SEQ	= convert_ppqn PPQN (500000,0,0) SEQ;

convert_ppqn _ _ []	= [];

convert_ppqn PPQN (TEMPO,S,T) [(K,S1,tempo TEMPO1)|SEQ]
			= [(K,T1,tempo TEMPO1)|
			   convert_ppqn PPQN (TEMPO1,S1,T1) SEQ]
			    where T1 = T+round (TEMPO/PPQN*(S1-S)/1000);

convert_ppqn PPQN (TEMPO,S,T) [(K,S1,MSG)|SEQ]
			= [(K,T1,MSG)|convert_ppqn PPQN (TEMPO,S1,T1) SEQ]
			    where T1 = T+round (TEMPO/PPQN*(S1-S)/1000);
