/* bsp16.q: Speichern einer MIDI-Datei */

import midi;

def REF = midi_open "bsp16";

public save NAME DIV SEQ;

save NAME DIV SEQ	= do (save_track F SEQ) (track_nums SEQ)
			    where F:MidiFile = midi_file_create NAME 1 DIV,
			      SEQ = convert DIV SEQ;

/* Bestimmung der Spurnummern */

track_nums SEQ		= list (set (map fst SEQ));

/* Speichern der Spuren */

save_track F SEQ K	= midi_file_write_track F (map pop (track K SEQ));

/* Extrahieren der Spuren (vgl. bsp14.q) */

track K SEQ		= filter (trackeq K) SEQ;

trackeq K (K,_,_)	= true;
trackeq _ _		= false otherwise;

/* Konvertieren der Millisekunden-Zeitstempel */

convert (FPS,TICKS) SEQ	= map (convert_smpte FPS TICKS) SEQ;

convert_smpte FPS TICKS (K,T,MSG)
			= (K,round (T*FPS*TICKS/1000),MSG);

convert PPQN SEQ	= convert_ppqn PPQN (500000,0,0) SEQ;

convert_ppqn _ _ []	= [];

convert_ppqn PPQN (TEMPO,T,S) [(K,T1,tempo TEMPO1)|SEQ]
			= [(K,S1,tempo TEMPO1)|
			   convert_ppqn PPQN (TEMPO1,T1,S1) SEQ]
			    where S1 = S+round ((T1-T)*1000*PPQN/TEMPO);

convert_ppqn PPQN (TEMPO,T,S) [(K,T1,MSG)|SEQ]
			= [(K,S1,MSG)|convert_ppqn PPQN (TEMPO,T1,S1) SEQ]
			    where S1 = S+round ((T1-T)*1000*PPQN/TEMPO);
