/* bsp17.q: Dynamik-Normalisierung einer MIDI-Datei */

import midi, bsp15, bsp16;

def REF = midi_open "bsp17";

public normalize NAME;

normalize NAME		= save NAME DIV (map (amp (127/MAX)) SEQ) if MAX>0
			    where SEQ = load NAME,
			      MAX = foldl max 0 (map vel SEQ),
			      DIV = midi_file_division (midi_file_open NAME);

/* Bestimmung der Dynamikwerte */

vel (_,_,note_on _ _ V)	= V;
vel _			= 0 otherwise;

/* Verstrkung der Dynamikwerte */

amp FACT (K,T,note_on C P V)
			= (K,T,note_on C P (round (FACT*V)));
amp FACT EV		= EV otherwise;
